<?php

require_once("supportcenter.php");

class SUPPORTCENTER_CTRL_Admin extends ADMIN_CTRL_Abstract {

	function myinit($menu) {	
		$this->setPageHeading( OW::getLanguage()->text('supportcenter', 'admin_settings_heading'));
		$this->setPageHeadingIconClass('ow_ic_gear_wheel');

		$this->addComponent('menu',$this->getMenu());
		$this->getComponent('menu')->getElement($menu)->setActive(true);
	}
	private function getMenu() {

		$menu=array(
			//key (also lang string), route, icon
			array("general",		"general",		"ow_ic_gear_wheel"),
			array("tags",			"tags",			"ow_ic_calendar"),
			array("articles",		"articles",		"ow_ic_files"),
			array("ticket_categories",	"ticket-categories",	"ow_ic_tag"),
			array("departments",		"departments",		"ow_ic_house"),
			array("tickets",		"tickets",		"ow_ic_reply"),
		);

		$menuItems = array();

		foreach($menu as $i=>$m) {
			$item=new BASE_MenuItem();
			$item->setLabel(OW::getLanguage()->text("supportcenter","admin_${m[0]}"));
			$item->setUrl(OW::getRouter()->urlForRoute("supportcenter-admin-${m[1]}"));
			$item->setKey($m[0]);
			$item->setIconClass($m[2]);
			$item->setOrder($i);
			array_push($menuItems,$item);
		}

		return new BASE_CMP_ContentMenu( $menuItems );
	}
	//forms
	function build_tag_form() {
		$language = OW::getLanguage();

		$form=new Form("supportcenter_form_add_tag");
		$form->setMethod(Form::METHOD_POST);
		$form->setEnctype(Form::ENCTYPE_MULTYPART_FORMDATA);

		$textField = new TextField("text");
		$textField->setLabel($language->text("supportcenter", "form_add_tag"));
		$textField->setHasInvitation(true);
		$textField->setRequired();

		$submit = new Submit("submit");
		$submit->setLabel($language->text("supportcenter", "form_add_tag_submit"));

		$form->addElement($textField);
		$form->addElement($submit);

		return $form;
	}
	function build_category_form() {
		$form=$this->build_tag_form();
		$form->getElement("text")->setLabel(OW::getLanguage()->text("supportcenter", "form_add_category"));
		return $form;
	}
	function build_department_form() {
		$form=$this->build_tag_form();
		$form->getElement("text")->setLabel(OW::getLanguage()->text("supportcenter", "form_add_department"));
		return $form;
	}
	function build_department_user_form() {
		$form=$this->build_tag_form();
		$form->getElement("text")->setLabel(OW::getLanguage()->text("supportcenter", "form_add_department_user"));
		return $form;
	}
	function build_article_form() {
		$language = OW::getLanguage();

		$form=new Form("supportcenter_form_article");
		$form->setMethod(Form::METHOD_POST);
		$form->setEnctype(Form::ENCTYPE_MULTYPART_FORMDATA);

		$text_title = new TextField("title");
		$text_title->setLabel($language->text("supportcenter", "form_article_title"));
		$text_title->setRequired();

		$buttons = array(
		    BOL_TextFormatService::WS_BTN_BOLD,
		    BOL_TextFormatService::WS_BTN_ITALIC,
		    BOL_TextFormatService::WS_BTN_UNDERLINE,
		    BOL_TextFormatService::WS_BTN_IMAGE,
		    BOL_TextFormatService::WS_BTN_LINK,
		    BOL_TextFormatService::WS_BTN_ORDERED_LIST,
		    BOL_TextFormatService::WS_BTN_UNORDERED_LIST,
		    BOL_TextFormatService::WS_BTN_MORE,
		    BOL_TextFormatService::WS_BTN_SWITCH_HTML,
		    BOL_TextFormatService::WS_BTN_HTML
		);
		$text_body = new WysiwygTextarea("body", $buttons);
		$text_body->setSize(WysiwygTextarea::SIZE_L);
		$text_body->setLabel($language->text("supportcenter", "form_article_body"));


		$categories=[];
		$cat_query=SupportCenterDB::tag_get();
		foreach($cat_query as $c) {
			$categories[$c["id"]]=$c["text"];
		}

		$cat1 = new Selectbox("cat1");
		$cat1->setLabel($language->text("supportcenter", "form_article_cat1"));
		$cat1->setInvitation("Select Tag");
		$cat1->setOptions($categories);
		$cat2 = new Selectbox("cat2");
		$cat2->setLabel($language->text("supportcenter", "form_article_cat2"));
		$cat2->setInvitation("Select Tag");
		$cat2->setOptions($categories);

		$submit = new Submit("submit");
		$submit->setLabel($language->text("supportcenter", "form_article_submit"));
		
		$form->addElement($text_title);
		$form->addElement($text_body);
		$form->addElement($cat1);
		$form->addElement($cat2);
		$form->addElement($submit);

		return $form;
	}
	function build_ticket_reply_form() {
		$language=OW::getLanguage();

		$form=new Form("supportcenter_form_ticket_reply");
		$form->setMethod(Form::METHOD_POST);
		$form->setEnctype(Form::ENCTYPE_MULTYPART_FORMDATA);

		$buttons = array(
		    BOL_TextFormatService::WS_BTN_BOLD,
		    BOL_TextFormatService::WS_BTN_ITALIC,
		    BOL_TextFormatService::WS_BTN_UNDERLINE,
		    BOL_TextFormatService::WS_BTN_IMAGE,
		    BOL_TextFormatService::WS_BTN_LINK,
		    BOL_TextFormatService::WS_BTN_ORDERED_LIST,
		    BOL_TextFormatService::WS_BTN_UNORDERED_LIST,
		    BOL_TextFormatService::WS_BTN_MORE,
		    BOL_TextFormatService::WS_BTN_SWITCH_HTML,
		    BOL_TextFormatService::WS_BTN_HTML
		);
		$text_body = new WysiwygTextarea("text", $buttons);
		$text_body->setSize(WysiwygTextarea::SIZE_L);
		$text_body->setLabel($language->text("supportcenter", "form_ticket_reply_text"));
		$text_body->setRequired();


		$submit = new Submit("submit");
		$submit->setLabel($language->text("supportcenter", "form_ticket_reply_submit"));

		$form->addElement($text_body);
		$form->addElement($submit);

		return $form;		
	}
	function build_settings_form() {
		$language=OW::getLanguage();

		$form=new Form("supportcenter_form_settings");

		$menu_pos = new Selectbox("menu_pos");
		$menu_pos->setLabel($language->text("supportcenter", "form_settings_menu_pos"));
		$menu_pos->setOptions(array(
			OW_Navigation::BOTTOM=>"Bottom",
			OW_Navigation::MAIN=>"Main"));

		$menu_pos->setRequired(true);

		$submit = new Submit("submit");
		$submit->setLabel($language->text("supportcenter", "form_ticket_reply_submit"));
		
		$form->addElement($menu_pos);
		$form->addElement($submit);
		return $form;
	}

	function general() {
		$this->myinit("general");

		$form=$this->build_settings_form();
		$this->addForm($form);

		if(OW::getRequest()->isPost() && $form->isValid($_POST)) {
			$values = $form->getValues();
			$form->reset();
			OW::getConfig()->saveConfig("supportcenter", "menu_pos", $values["menu_pos"]);
		}
		$form->getElement("menu_pos")->setValue( OW::getConfig()->getValues("supportcenter")["menu_pos"] );

		OW::getNavigation()->deleteMenuItem("supportcenter","support");
		OW::getNavigation()->addMenuItem(OW::getConfig()->getValues("supportcenter")["menu_pos"], 'supportcenter-support', 'supportcenter', 'support', OW_Navigation::VISIBLE_FOR_MEMBER);
	}


	//tags
	function tagsDelete($params) {
		SupportCenterDB::tag_delete($params["id"]);
	        $this->redirect( OW::getRouter()->urlForRoute("supportcenter-admin-tags"));
		//OW::getFeedback()->info("Tag deleted");
		//$this->redirectToAction("tags");
	}
	function tags() {
		$this->myinit("tags");

		$form=$this->build_tag_form();
		$this->addForm($form);

		if(OW::getRequest()->isPost() && $form->isValid($_POST)) {
			$values = $form->getValues();
			$form->reset();
			SupportCenterDB::tag_add($values["text"]);
			OW::getFeedback()->info("Tag created");
		}

		$query=SupportCenterDB::tag_get();
		$tags=array();
		foreach($query as $data) {
			array_push($tags,array(
				"id" => $data["id"],
				"text" => $data["text"],
				"url_delete" => OW::getRouter()->urlForRoute("supportcenter-admin-tags-delete",array("id"=>$data["id"])),
				//"url_edit" => OW::getRouter()->urlForRoute("supportcenter-admin-tags-edit",array("id"=>$data["id"]))),
			));
		}
		$this->assign("items",$tags);
		$this->assign("text_label_list",OW::getLanguage()->text("supportcenter","tag_list"));
		$this->assign("text_label_add",OW::getLanguage()->text("supportcenter","tag_add"));
	}
	//articles
	function articles($params) {
		$this->myinit("articles");

		$a=SupportCenterDB::article_list();
		$articles=array();
		foreach($a as $article) {
			array_push($articles,array(
				"id" => $article["id"],
				"title" => $article["title"],
				"rating" => round($article["rating"],2),
				"url_edit" => OW::getRouter()->urlForRoute("supportcenter-admin-articles-edit",array("id"=>$article["id"])),
				"url_delete" => OW::getRouter()->urlForRoute("supportcenter-admin-articles-delete",array("id"=>$article["id"]))
			));
		}

		$this->assign("articles",$articles);
		$this->assign("url_new",OW::getRouter()->urlForRoute("supportcenter-admin-articles-new"));
	}
	function articlesNew() {
		$this->myinit("articles");

		$form=$this->build_article_form();
		$this->addForm($form);

		if(OW::getRequest()->isPost() && $form->isValid($_POST)) {
			$values = $form->getValues();
			$form->reset();

			SupportCenterDB::article_add([
				"title" => $values["title"],
				"body" => $values["body"],
				"cat1" => $values["cat1"],
				"cat2" => $values["cat2"],
			]);
		        $this->redirect( OW::getRouter()->urlForRoute("supportcenter-admin-articles"));
			//OW::getFeedback()->info("Article created");
			//$this->redirectToAction("articles");
			return;
		}
		$this->assign("url_cancel",OW::getRouter()->urlForRoute("supportcenter-admin-articles"));
	}
	function articlesDelete($params) {
		SupportCenterDB::article_delete($params["id"]);
	        $this->redirect( OW::getRouter()->urlForRoute("supportcenter-admin-articles"));
		//OW::getFeedback()->info("Article deleted");
		//$this->redirectToAction("articles");
	}
	function articlesEdit($params) {
		$this->myinit("articles");

		$form=$this->build_article_form();
		$this->addForm($form);

		$id=$params["id"];

		if(OW::getRequest()->isPost() && $form->isValid($_POST)) {
			$values=$form->getValues();
			$form->reset();

			SupportCenterDB::article_update([
				"id" => $id,
				"title" => $values["title"],
				"body" => $values["body"],
				"cat1" => $values["cat1"],
				"cat2" => $values["cat2"],
			]);
		        $this->redirect( OW::getRouter()->urlForRoute("supportcenter-admin-articles"));
		}

		$article=SupportCenterDB::article_get($id);
		$form->getElement("title")->setValue($article["title"]);
		$form->getElement("body")->setValue($article["body"]);
		$form->getElement("cat1")->setValue($article["cat1"]);
		$form->getElement("cat2")->setValue($article["cat2"]);

		$this->assign("url_cancel",OW::getRouter()->urlForRoute("supportcenter-admin-articles"));
	}

	//tickets
	function ticketCategories() {
		$this->myinit("ticket_categories");

		$form=$this->build_category_form();
		$this->addForm($form);

		if(OW::getRequest()->isPost() && $form->isValid($_POST)) {
			$values = $form->getValues();
			$form->reset();
			SupportCenterDB::ticket_category_new($values["text"]);
			OW::getFeedback()->info("Category created");
		}

		$query=SupportCenterDB::ticket_category_list();
		$cats=array();
		foreach($query as $data) {
			array_push($cats,array(
				"id" => $data["id"],
				"text" => $data["text"],
				"url_delete" => OW::getRouter()->urlForRoute("supportcenter-admin-ticket-categories-delete",array("id"=>$data["id"])),
				//"url_edit" => OW::getRouter()->urlForRoute("supportcenter-admin-ticket-categories-edit",array("id"=>$data["id"]))),
			));
		}
		$this->assign("items",$cats);
		$this->assign("text_label_list",OW::getLanguage()->text("supportcenter","category_list"));
		$this->assign("text_label_add",OW::getLanguage()->text("supportcenter","category_add"));
	}
	function ticketCategoriesDelete($params) {
		SupportCenterDB::ticket_category_delete($params["id"]);
	        $this->redirect(OW::getRouter()->urlForRoute("supportcenter-admin-ticket-categories"));
	}

	function get_ticket_status($ticket) {
		$stat=array("New","Unread","Read","Answered");
		if($ticket["requested_deletion"]!=0) {
			return "To delete";
		}
		return $stat[$ticket["status"]];
	}
	function tickets() {
		$this->myinit("tickets");

		$tickets_q=SupportCenterDB::ticket_list();
		$tickets=array();
		foreach($tickets_q as $data) {
			array_push($tickets,array(
				"text"=>$data["subject"],
				"updated"=>$data["updated"],
				"status"=>$this->get_ticket_status($data),
				//"url_view"=>"/settings/tickets/view/${data["id"]}",
				"url_view"=>OW::getRouter()->urlForRoute("supportcenter-admin-tickets-view",array("id"=>$data["id"])),
				"url_delete"=>OW::getRouter()->urlForRoute("supportcenter-admin-tickets-delete",array("id"=>$data["id"])),
				"request_deletion"=>$data["requested_deletion"],
			));
		}
		$this->assign("items",$tickets);
		$this->assign("text_label_list",OW::getLanguage()->text("supportcenter","ticket_list"));
	}
	public function ticketsView($param) {
		$this->myinit("tickets");

		$ticket=SupportCenterDB::ticket_get($param["id"]);

		if($ticket["status"]!=3) {
			SupportCenterDB::ticket_set_status($param["id"],2);
		}

		$ticket["author"]=BOL_UserService::getInstance()->getDisplayName($ticket["author_id"]);

		$form=$this->build_ticket_reply_form();
		$this->addForm($form);
		if(OW::getRequest()->isPost() && $form->isValid($_POST)) {
			$values = $form->getValues();
			$form->reset();

			SupportCenterDB::ticket_add_message(array(
				"ticket_id"=>$param["id"],
				"author_id"=>OW::getUser()->getId(),
				"text"=>$values["text"]
			),3);

			OW::getFeedback()->info("Message posted");

		        $userId = OW::getUser()->getId();
			$avatars = BOL_AvatarService::getInstance()->getAvatarsUrlList(array($userId));
			$target_user=$ticket["author_id"];

			$notificationParams = array(
			    'pluginKey' => 'supportcenter',
			    'action' => 'ticketUpdated',
			    'entityType' => 'supportcenter-ticketUpdated',
			    'entityId' => $target_user,
			    'userId' => $target_user,
			    'time' => time()
			);
			$notificationData = array(
			    'string' => array(
				'key' => 'supportcenter+ticket_notification',
				'vars' => array(
				    'content' => $ticket["subject"]
				)
			    ),
			    'avatar' => OW::getPluginManager()->getPlugin("supportcenter")->getStaticUrl()."img/ic_reply.png",
				"url"=>OW::getRouter()->urlForRoute("supportcenter-tickets-view",array("id"=>$ticket["id"]))
			);

			$event = new OW_Event('notifications.add',$notificationParams,$notificationData);
		        OW::getEventManager()->trigger($event);
		}

		$messages_q=SupportCenterDB::ticket_get_messages($ticket["id"]);
		$messages=array();
		foreach($messages_q as $data) {
			array_push($messages,array(
				"author"=>BOL_UserService::getInstance()->getDisplayName($data["author_id"]),
				"text"=>$data["text"],
				"created"=>$data["created"],
			));
		}

		$this->assign("ticket",$ticket);
		$this->assign("messages",$messages);
		$this->assign("url_back",OW::getRouter()->urlForRoute("supportcenter-admin-departments-view",array("id"=>$ticket["department_id"])));
		$this->assign("url_delete",OW::getRouter()->urlForRoute("supportcenter-admin-tickets-delete",array("id"=>$ticket["id"])));
	}
	function ticketsDelete($params) {
		SupportCenterDB::ticket_delete($params["id"]);
	        $this->redirect(OW::getRouter()->urlForRoute("supportcenter-admin-tickets"));
	}


	function departments() {
		$this->myinit("departments");

		$form=$this->build_department_form();
		$this->addForm($form);

		if(OW::getRequest()->isPost() && $form->isValid($_POST)) {
			$values = $form->getValues();
			$form->reset();
			SupportCenterDB::department_new($values["text"]);
			OW::getFeedback()->info("Department created");
		}

		$query=SupportCenterDB::department_list();
		$deps=array();
		foreach($query as $data) {
			array_push($deps,array(
				"id" => $data["id"],
				"text" => $data["text"],
				"url_delete" => OW::getRouter()->urlForRoute("supportcenter-admin-departments-delete",array("id"=>$data["id"])),
				"url_view" => OW::getRouter()->urlForRoute("supportcenter-admin-departments-view",array("id"=>$data["id"])),
				//"url_edit" => OW::getRouter()->urlForRoute("supportcenter-admin-departments-edit",array("id"=>$data["id"]))),
			));
		}
		$this->assign("items",$deps);
		$this->assign("text_label_list",OW::getLanguage()->text("supportcenter","department_list"));
		$this->assign("text_label_add",OW::getLanguage()->text("supportcenter","department_add"));

	}
	function departmentsView($params) {
		$this->myinit("departments");

		$dep_id=$params["id"];

		$form=$this->build_department_user_form();
		$this->addForm($form);
		if(OW::getRequest()->isPost() && $form->isValid($_POST)) {
			$values = $form->getValues();
			$form->reset();

			$user = BOL_UserService::getInstance()->findByUsername($values["text"]);

			if ($user === null) {
				OW::getFeedback()->error(OW::getLanguage()->text("supportcenter", "user_not_found"));
			}
			else {
				SupportCenterDB::department_user_add($dep_id,$user->getId());
				OW::getFeedback()->info("User added to department");
			}
		}

		$query_dept=SupportCenterDB::department_get($dep_id);
		$query_users=SupportCenterDB::department_get_users($dep_id);
		$query_tickets=SupportCenterDB::ticket_list_by_department($dep_id);

		$users=array();
		foreach($query_users as $data) {
			array_push($users,array(
				"text"=>BOL_UserService::getInstance()->getDisplayName($data["user_id"]),
				"url_delete"=>OW::getRouter()->urlForRoute("supportcenter-admin-departments-user-delete",array("dep_id"=>$params["id"],"user_id"=>$data["user_id"])),
			));
		}
		$tickets=array();
		foreach($query_tickets as $data) {
			array_push($tickets,array(
				"text"=>$data["subject"],
				"updated"=>$data["updated"],
				"status"=>$this->get_ticket_status($data),
				"url_delete"=>OW::getRouter()->urlForRoute("supportcenter-admin-tickets-delete",array("id"=>$data["id"])),
				"url_view"=>OW::getRouter()->urlForRoute("supportcenter-admin-tickets-view",array("id"=>$data["id"])),
			));
		}

		$department_name=$query_dept["text"];

		$this->assign("text_ticket_list",$department_name." ".OW::getLanguage()->text("supportcenter","department_ticket_list"));



		$this->assign("tickets",$tickets);
		$this->assign("items",$users);
		$this->assign("text_label_list",OW::getLanguage()->text("supportcenter","department_user_list"));
		$this->assign("text_label_add",OW::getLanguage()->text("supportcenter","department_user_add")." to ${department_name} department");
	}
	function departmentsDelete($params) {
		SupportCenterDB::department_delete($params["id"]);
	        $this->redirect(OW::getRouter()->urlForRoute("supportcenter-admin-departments"));
	}
	function departmentsUserDelete($params) {
		SupportCenterDB::department_user_delete($params["dep_id"],$params["user_id"]);
	        $this->redirect(OW::getRouter()->urlForRoute("supportcenter-admin-departments-view",array("id"=>$params["dep_id"])));
	}
}





